/*
 * @COPYRIGHT@
 * 
 * x-kernel v3.2
 * 
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 * 
 * @COPYRIGHT@
 *
 * $RCSfile: alpha_util.c,v $
 *
 * HISTORY
 * $Log: alpha_util.c,v $
 * Revision 1.2  1994/06/11  00:02:43  menze
 * Added copyright notice
 *
 * Revision 1.1  1994/05/14  23:30:27  davidm
 * Initial revision
 *
 */
/*
 * Miscellaneous small utilities.
 */
#include <machine/rpb.h>
#include "scout.h"
#include "scout_util.h"
#include "alpha_misc.h"
#include "alpha_pal.h"


void
flush_icache(void)
{
    asm volatile ("call_pal %0" :: "i"(PAL_imb));
} /* flush_icache */


void
halt(void)
{
    asm volatile ("call_pal %0" :: "i"(PAL_halt));
} /* halt */


void
scout_flush_write_to_memory (void)
{
    asm volatile ("mb");
} /* scout_flush_write_to_memory */


void
scout_udelay(long usec)
{
    u_int start, delta;
    static int cycles_per_usec = 0;

    if (!cycles_per_usec) {
	cycles_per_usec = rpb->rpb_counter / 1000000L;
    } /* if */
    delta = usec * cycles_per_usec;
    start = read_itimer();
    while (read_itimer() - start < delta) {
	/* skip */
    } /* while */
} /* scout_udelay */

			/*** end of alpha_utils.c ***/
