/*
 * @COPYRIGHT@
 * 
 * x-kernel v3.2
 * 
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 * 
 * @COPYRIGHT@
 *
 * $RCSfile: scout_lifo.h,v $
 *
 * HISTORY
 * $Log: scout_lifo.h,v $
 * Revision 1.2  1994/06/11  00:03:02  menze
 * Added copyright notice
 *
 * Revision 1.1  1994/05/15  00:06:16  davidm
 * Initial revision
 *
 */
#ifndef scout_lifo_h
#define scout_lifo_h

/*
 * This module provides a LIFO queueing service for a single producer
 * and a single consumer that operate concurrently.
 */

struct scout_lifo_link {
    struct scout_lifo_link *next;
};

typedef struct {
    struct scout_lifo_link *head;
} Scout_LIFO;

extern void	scout_lifo_init (Scout_LIFO *s);
extern void	scout_lifo_push (Scout_LIFO *s, void *element);
extern void	*scout_lifo_pop (Scout_LIFO *s);

#endif /* scout_lifo_h */
