/*
 * @COPYRIGHT@
 * 
 * x-kernel v3.2
 * 
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 * 
 * @COPYRIGHT@
 *
 * $RCSfile: scout_queue.h,v $
 *
 * HISTORY
 * $Log: scout_queue.h,v $
 * Revision 1.2  1994/06/11  00:03:03  menze
 * Added copyright notice
 *
 * Revision 1.1  1994/05/15  00:06:34  davidm
 * Initial revision
 *
 */
#ifndef scout_queue_h
#define scout_queue_h

/*
 * This module provides a general queueing service if producers and
 * consumers operate synchronously (i.e., under control of
 * scout_thread.c).
 */
struct scout_queue_link {
    struct scout_queue_link *next;
};

typedef struct {
    struct scout_queue_link *head;
    struct scout_queue_link *tail;
} Scout_Queue;

#define scout_queue_head(q)	((q)->head)
#define scout_queue_tail(q)	((q)->tail)

extern void	scout_queue_init (Scout_Queue *q);
extern void	scout_queue_append (Scout_Queue *q, void *element);
extern void	scout_queue_insert (Scout_Queue *q,
				    void *after, void *element);
extern void	*scout_queue_remove (Scout_Queue *q);
extern void	scout_queue_delete (Scout_Queue *q, void *after);

#endif /* scout_queue_h */
